function fPlot(func,D,xMin,xMax,lowerBound)
switch func
  case {-3,-2,2}
    a=0.001; % For highly variable functions
  otherwise
    a=0.01;
end
step=a*max(xMax-xMin);

switch D
  case 1 % D=1
    X=xMin:step:xMax;
    lX=length(X);
    
    for i=1:lX
      Y(i)=fit(X(i),func);
    end
    plot(X,Y)
    axis([xMin,xMax,lowerBound, max(Y)]);
    %axis([xMin,xMax]);
    xlabel("x");
    ylabel("f","Rotation", 0);
    
  case 2 % D=2
    X=xMin(1):step:xMax(1);
    Y=xMin(2):step:xMax(2);
    
    lX=length(X);
    lY=length(Y);
    
    [Xx,Yy]=meshgrid(X,Y);
    
    for lx=1:lX
      x=X(lx);
      for ly=1:lY
        y=Y(ly);
        Z(lx,ly)=fit([x,y],func);
      end
    end
    %surf(Xx,Yy,Z');
    mesh(Xx,Yy,Z');
    xlabel("x");
    ylabel("y");
    zlabel("f","Rotation",0);
    alpha 0.01 % For transparency
end

end