function [xMin, xMax, lowerBound,quantis,D]=get_func(func,D0)

One=ones(1,D0);
Zero=zeros(1,D0);
D=D0;
quantis=[];
switch func
  case -3 % abs(sin(x) + ax)
    xMin=Zero;
    xMax=10*One;
    lowerBound=-0.1;
    
  case -2 % Test
    xMin=Zero;
    xMax=10*One;
    lowerBound=-0.1;
    
  case 2 % Inverted Rastrigin
    % Difficult.
    xMin=-10*One;
    xMax=-xMin;
    lowerBound=-10;
    
  case {-1,0,3,4,5}
    xMin=Zero;
    xMax=10*One;
    lowerBound=-0.1;
    
  case 6
    xMax=10*One;
    xMin=-xMax;
    lowerBound=-0.1;
    
  case 7
    xMin=-One;
    xMax=One;
    lowerBound=-0.1;
    
  case 8
    xMin=-10*One;
    xMax=10*One;
    lowerBound=-D0*13^3;
    
  case 9 % Rosenbrock
    xMax=100*One;
    xMin=-xMax;
    lowerBound=-0.1;
    
  case 10    % Six Hump Camel Back
    D=2;
    xMin=[-2,-1];
    xMax=-xMin;
    lowerBound=-1.1;
    
  case 11 % Pressure Vessel 
    D=4;
    q=0.0625;
    quantis=[q,q,0,0];
    xMin=[q,q,10,10];
    xMax=[99,99,200,200];
    lowerBound=6000;
    
  case 12 % Gear Train
    D=4;
    ones4=ones(1,4);
    xMin=12*ones4;
    xMax=60*ones4;
    quantis=[1,1,1,1];
    lowerBound=0;
    
  case 13 % Griewank
    xMax=100*One;
    xMin=-xMax;
    lowerBound=-0.001; %0;
    
  case 14 % Sin Sin
    xMin=-2.7*One;
    xMax=7.5*One;
    lowerBound=-2*D;
    
  case {15,152,153,154,155,156} %CEC 2011. Frequency-Modulated (FM) Sound Waves
    % COUNTER EXAMPLE
    lowerBound=-1;
    switch func
      case 15 % The complete problem
        D=6;
      case 152
        D=5;
      case 153
        D=4;
      case 154
        D=3;
      case 155
        D=2;
      case 156
        D=1;
    end
    xMin=-6.4*ones(1,D);
    xMax=6.35*ones(1,D);
    %xMin=-500*ones(1,D); xMax=-xMin;
    
    
  case 16 %CEC 2011. The bifunctional catalyst blend optimal control problem
    D=1;
    xMin=0.6;
    xMax=0.9;
    lowerBound=-0.00001;
    
  case 17 % CEC 2011. Transmission Network Expansion Planning
    % Difficult. 
    % Minimum 220. Most stochastic methods find it.
    % And quite sensitive to the lower bound.
    D=7;
    xMin=ones(1,D);
    xMax=15*xMin;
    lowerBound=200;
 
    % ...
  case 39 % Branin
    D=2;
    xMin=[-5, 0];
    xMax=[10,15];
    lowerBound=0;
    
  case 40 % Beale
    D=2;
    xMin=[-4.5,-4.5];
    xMax=-xMin;
    lowerBound=-0.1;
    
  case 41 % Eggholder
    D=2;
    xMin=[-512,-512];
    xMax=-xMin;
    lowerBound=-1000; 
    
  case 42 % Eggholder +
    D=2;
    xMin=[-600,-600];
    xMax=-xMin;
    lowerBound=-1000; 
    
  case {43,44} % Schaffer 2
    D=2;
    xMin=[-100,-100];
    xMax=-xMin;
    lowerBound=-0.1;
    
  case {45,46} % Drop Wave
    D=2;
    xMin=[-5.12,-5.12];
    xMax=-xMin;
    lowerBound=-1.1;
    
  case 47 % Holder Table
    D=2;
    xMin=[-10,-10];
    xMax=-xMin;
    lowerBound=-20;
    
  case 48 % Langermann
    D=2;
    xMin=[0,0];
    xMax=[10,10];
    lowerBound=-6;
    
  case 49 % Lévy
    xMin=-10*One;
    xMax=-xMin;
    lowerBound=-0.1;
    
  case 50 % Shubert
    D=2;
    xMin=[-10,-10];
    xMax=-xMin;
    lowerBound=-200;
    
  case 51 % Perm 0 D B
    xMin=-D*One;
    xMax=-xMin;
    lowerBound=-0.1;
    
  otherwise
    xMin=-10*One;
    xMax=10*One;
    lowerBound=-0.1;
end
if D~=D0
  fprintf('\n Warning. The dimension of this problem is %i, not %i',D,D0)
end
end